var app = angular.module('bookmein.book', ['ionic', 'bookmein.user'])

app.controller('EventsCtrl', function($scope, $http, User, $state, $ionicHistory) {

  var link = window.localStorage['url'] + "/book/app/checklogin.php"
  $http.post(link, {username : window.localStorage['username'], password : window.localStorage['password']})
    .success(function (data) {
      if(data == '"t"'){
        $http.get(window.localStorage['url'] + "/book/app/book.php")
          .success(function (data) {
            if(data==0){
              $scope.response = "No events found.";
            } else {
              $scope.events = data;
              $scope.response = " ";
            };
          });
          } else {
            $scope.response = "Password has changed. Please log out and try again."
          };
    });


  $scope.doRefresh = function() {
    var link = window.localStorage['url'] + "/book/app/checklogin.php"
    $http.post(link, {username : window.localStorage['username'], password : window.localStorage['password']})
      .success(function (data) {
        if(data == '"t"'){
          $http.get(window.localStorage['url'] + "/book/app/book.php")
            .success(function (data) {
              if(data==0){
                $scope.response = "No events found.";
              } else {
                $scope.events = data;
                $scope.response = " ";
              };
            })
          .finally(function() {
            $scope.$broadcast('scroll.refreshComplete');
          });
        } else {
          $scope.response = "Password has changed. Please log out and try again."
        };
      });    
  };


  $scope.book = function(eventid) {

      var link = window.localStorage['url'] + "/book/app/checklogin.php"
  $http.post(link, {username : window.localStorage['username'], password : window.localStorage['password']})
    .success(function (data) {
      if(data == '"t"'){
        var link = window.localStorage['url'] + "/book/app/bookin.php"
          $http.post(link, {event_id : eventid, username : window.localStorage['username']})
            .success(function (data) {
              if(data == '"t"'){
                $ionicHistory.nextViewOptions({historyRoot: true});
                $state.go('app.bookedevents');
              } else {
                $scope.response = data;
              };
            });
      };
  });
  };

  $scope.book_number = function(eventid){

    window.localStorage['transfervalue'] = eventid;
    $state.go('app.booknumber');

  };

  $scope.message = function(hostid) {

    window.localStorage['transfervalue'] = hostid;
    $state.go('app.createmessage');

  };

});

app.controller('BookNumberCtrl', function($scope, $http, $state, $ionicHistory) {

  $scope.submit = function(){

      var link = window.localStorage['url'] + "/book/app/checklogin.php"
  $http.post(link, {username : window.localStorage['username'], password : window.localStorage['password']})
    .success(function (data) {
      if(data == '"t"'){
        var link = window.localStorage['url'] + "/book/app/bookinnumber.php"
          $http.post(link, {event_id : window.localStorage['transfervalue'], requested : $scope.data.people, username : window.localStorage['username']})
            .success(function (data) {
              if(data == '"t"'){
                $ionicHistory.nextViewOptions({historyRoot: true});
                $state.go('app.bookedevents');
              } else {
                $scope.response = data;
              };
            });
      };
  });



  };


  });


app.controller('CreateCtrl', function($scope, $http, $state) {

  var link = window.localStorage['url'] + "/book/app/checklogin.php"
  $http.post(link, {username : window.localStorage['username'], password : window.localStorage['password']})
    .success(function (data) {
      if(data == '"t"'){
        $scope.submit = function() {
          window.localStorage['event_title'] = $scope.data.title;
          window.localStorage['event_description'] = $scope.data.description;
          window.localStorage['people'] = $scope.data.people;
          
          
            if($scope.choice == "0"){
              window.localStorage['event_type'] = "0";
            } else if($scope.choice == "1"){
              window.localStorage['event_type'] = "1";
            } else if($scope.choice == "2"){
              window.localStorage['event_type'] = "2";
            } else {
              window.localStorage['event_type'] = "0";
            };
            $state.go('app.eventstart');

        };
      } else {
        $scope.response = "Password has changed. Please log out and try again."
      };
    });
});

app.controller('EventStartCtrl', function($scope, $http, $state, $filter) {

  $scope.submit = function() {
      
         var datetimeconv = $filter('date')($scope.datetimeValue, 'yyyy-MM-dd HH:mm:ss');
         window.localStorage['event_start'] = datetimeconv;
          $state.go('app.eventstop');
      };

});

app.controller('EventStopCtrl', function($scope, $http, $state, $filter) {

  $scope.submit = function() {
      
         var datetimeconv = $filter('date')($scope.datetimeValue, 'yyyy-MM-dd HH:mm:ss');
         window.localStorage['event_stop'] = datetimeconv;
          $state.go('app.eventsubmit');
      };

});

app.controller('EventSubmitCtrl', function($scope, $http, $state, $ionicHistory) {

  $scope.event_title = window.localStorage['event_title'];
  $scope.event_description = window.localStorage['event_description'];
  $scope.event_start = window.localStorage['event_start'];
  $scope.event_stop = window.localStorage['event_stop'];
  $scope.event_people = window.localStorage['people'];
  $scope.event_type = window.localStorage['event_type'];
  if(window.localStorage['event_type'] == "0"){
    $scope.event_display = "Attendees";
  };
   if(window.localStorage['event_type'] == "1"){
    $scope.event_display = "Rooms";
  };
   if(window.localStorage['event_type'] == "2"){
    $scope.event_display = "Seats";
  };

  $scope.submit = function() {
       
      var link = window.localStorage['url'] + "/book/app/eventsubmit.php"
      $http.post(link, {username : window.localStorage['username'], event_title : window.localStorage['event_title'], event_description : window.localStorage['event_description'], event_start : window.localStorage['event_start'], event_stop : window.localStorage['event_stop'], event_people : window.localStorage['people'], event_type : window.localStorage['event_type']}).then(function (res){
        if(res.data == '"t"'){
          window.localStorage.removeItem('event_title');
          window.localStorage.removeItem('event_description');
          window.localStorage.removeItem('event_start');
          window.localStorage.removeItem('event_stop');
          window.localStorage.removeItem('people');
          window.localStorage.removeItem('event_type');
          $ionicHistory.nextViewOptions({historyRoot: true});
          $state.go('app.book');
        } else {
          $scope.response = res.data;
        };
      });



  };

});

app.controller('MyEventsCtrl', function($scope, $http, $state, $ionicHistory) {      
  
  var link = window.localStorage['url'] + "/book/app/checklogin.php"
  $http.post(link, {username : window.localStorage['username'], password : window.localStorage['password']})
    .success(function (data) {
      if(data == '"t"'){
        var link = window.localStorage['url'] + "/book/app/myevents.php"
        $http.post(link, {username : window.localStorage['username']})
          .success(function (data) {
            if(data==0){
              $scope.response = "No events found.";
            } else {
              $scope.events = data;
              $scope.response = " ";
            };
          });
      } else {
        $scope.response = "Password has changed. Please log out and try again."
      };
    });

  $scope.doRefresh = function() {
    var link = window.localStorage['url'] + "/book/app/checklogin.php"
    $http.post(link, {username : window.localStorage['username'], password : window.localStorage['password']})
      .success(function (data) {
        if(data == '"t"'){
          $http.post(link, {username : window.localStorage['username']})
            .success(function (data) {
              if(data==0){
                $scope.response = "No events found.";
              } else {
                $scope.events = data;
                $scope.response = " ";
              };
            })
        .finally(function() {
          $scope.$broadcast('scroll.refreshComplete');
        });
        } else {
          $scope.response = "Password has changed. Please log out and try again."
        };
      });
  };

  $scope.attendees = function(eventid) {

    window.localStorage['transfervalue'] = eventid;
    $state.go('app.attendees');

  };

  $scope.remove = function(eventid){

    var link = window.localStorage['url'] + "/book/app/checklogin.php"
  $http.post(link, {username : window.localStorage['username'], password : window.localStorage['password']})
    .success(function (data) {
      if(data == '"t"'){
        var link = window.localStorage['url'] + "/book/app/removeevent.php"
          $http.post(link, {eventid : eventid})
            .success(function (data) {
              if(data == '"t"'){
                window.location.reload(true);
              };
            });
      };
  });
  };
});


app.controller('MyBookedCtrl', function($scope, $http, $state) {
  var link = window.localStorage['url'] + "/book/app/checklogin.php"
  $http.post(link, {username : window.localStorage['username'], password : window.localStorage['password']})
    .success(function (data) {
      if(data == '"t"'){
        var link = window.localStorage['url'] + "/book/app/bookedevents.php"
        $http.post(link, {username : window.localStorage['username']})
          .success(function (data) {
            if(data==0){
              $scope.response = "No events found.";
            } else {
              $scope.events = data;
              $scope.response = " ";
            };
          });
      } else {
        $scope.response = "Password has changed. Please log out and try again."
      };

    });

  $scope.doRefresh = function() {
    var link = window.localStorage['url'] + "/book/app/checklogin.php"
    $http.post(link, {username : window.localStorage['username'], password : window.localStorage['password']})
      .success(function (data) {
        if(data == '"t"'){
          $http.post(link, {username : window.localStorage['username']})
            .success(function (data) {
              if(data==0){
                $scope.response = "No events found.";
              } else {
                $scope.events = data;
                $scope.response = " ";
              };
            })
        .finally(function() {
          $scope.$broadcast('scroll.refreshComplete');
        });
        } else {
          $scope.response = "Password has changed. Please log out and try again."
        };
      });
  };

  $scope.message = function(hostid) {

    window.localStorage['transfervalue'] = hostid;
    $state.go('app.createmessage');

  };

   $scope.remove = function(eventid, event_type){


    if(event_type == "0"){
    var link = window.localStorage['url'] + "/book/app/checklogin.php"
  $http.post(link, {username : window.localStorage['username'], password : window.localStorage['password']})
    .success(function (data) {
      if(data == '"t"'){
        var link = window.localStorage['url'] + "/book/app/removebooking.php"
          $http.post(link, {eventid : eventid, username : window.localStorage['username']})
            .success(function (data) {
              if(data == '"t"'){
                window.location.reload(true);
              };
            });
      };
  });
  };

  if(event_type == "1" || event_type == "2"){

    var link = window.localStorage['url'] + "/book/app/checklogin.php"
  $http.post(link, {username : window.localStorage['username'], password : window.localStorage['password']})
    .success(function (data) {
      if(data == '"t"'){
        var link = window.localStorage['url'] + "/book/app/removebookingnumber.php"
          $http.post(link, {eventid : eventid, username : window.localStorage['username']})
            .success(function (data) {
              if(data == '"t"'){
                window.location.reload(true);
              };
            });
      };
  });
  };

  };
});

app.controller('AttendeesCtrl', function($scope, $http, $state) {

    var link = window.localStorage['url'] + "/book/app/attendees.php"
    $http.post(link, {event_id : window.localStorage['transfervalue']})
    .success(function (data) {
      $scope.attendees = data;

    });

    $scope.remove = function(userid, event_type){


    if(event_type == "0"){
    var link = window.localStorage['url'] + "/book/app/checklogin.php"
  $http.post(link, {username : window.localStorage['username'], password : window.localStorage['password']})
    .success(function (data) {
      if(data == '"t"'){
        var link = window.localStorage['url'] + "/book/app/removeuserbooking.php"
          $http.post(link, {userid : userid, eventid : window.localStorage['transfervalue']})
            .success(function (data) {
              if(data == '"t"'){
                $state.go('app.myevents');
              };
            });
      };
  });
  };

  if(event_type == "1" || event_type == "2"){
    var link = window.localStorage['url'] + "/book/app/checklogin.php"
  $http.post(link, {username : window.localStorage['username'], password : window.localStorage['password']})
    .success(function (data) {
      if(data == '"t"'){
        var link = window.localStorage['url'] + "/book/app/removeuserbookingnumber.php"
          $http.post(link, {userid : userid, eventid : window.localStorage['transfervalue']})
            .success(function (data) {
              if(data == '"t"'){
                $state.go('app.myevents');
              };
            });
      };
  });
  };





  };

  $scope.message = function(userid){
    window.localStorage['messageuser'] = userid;
    $state.go('app.messageuser');
  };
});
