<?php

/** Update Settings For System **/
function update_settings(){
    if(isset($_POST['settings_submit'])){
        
        $title = clean($_POST['title']);
        $subheader = clean($_POST['subheader']);
        $url = clean($_POST['url']);
        $admin_email = clean($_POST['admin_email']);
        $bg_colour = clean($_POST['bg_colour']);
        $title_colour = clean($_POST['title_colour']);
        $text_colour = clean($_POST['text_colour']);
        $submit_colour = clean($_POST['submit_colour']);
        $hover_colour = clean($_POST['hover_colour']);
        $timezone = clean($_POST['timezone']);
        
        $sql = "UPDATE settings SET title = '".escape($title)."', subheader = '".escape($subheader)."', url = '".escape($url)."', admin_email = '".escape($admin_email)."', bg_colour = '".escape($bg_colour)."', title_colour = '".escape($title_colour)."', text_colour = '".escape($text_colour)."', submit_colour = '".escape($submit_colour)."', hover_colour = '".escape($hover_colour)."', timezone = '".escape($timezone)."' WHERE id = '1'";
        query($sql);
        
        echo "Settings updated <br><br>"; 
    } 
}

/** Update User Profile **/
function update_profile(){
    if(isset($_POST['profile_submit'])){
        
        if(isset($_SESSION['username'])){
            $username = $_SESSION['username'];    
        } else if(isset($_COOKIE['username'])){   
            $username = $_COOKIE['username'];    
        }
        
        $phonelen = 11;
        
        $first_name = clean($_POST['first_name']);
        $last_name = clean($_POST['last_name']);
        $phone_number = clean($_POST['phone_number']);
        
        if(strlen($phone_number) != $phonelen){
            validation_errors("Your contact number must be {$phonelen} digits.");
        } else {
            
            $sql = "UPDATE users SET first_name = '".escape($first_name)."', last_name = '".escape($last_name)."', phone_number = '".escape($phone_number)."' WHERE username = '$username'";
        query($sql);
            
        echo "Profile Updated <br><br>";
        
        }
    }
}

/** Update User Password **/
function update_password(){
    if(isset($_POST['update_password'])){
        
        $old_password = clean($_POST['old_password']);
        $new_password = clean($_POST['new_password']);
        $verify_password = clean($_POST['verify_password']);
        
        if($new_password == $verify_password){
            if(isset($_SESSION['username'])){
                $username = $_SESSION['username'];    
            } else if(isset($_COOKIE['username'])){   
                $username = $_COOKIE['username'];    
        }
        
        $sql = "SELECT password, id FROM users WHERE username = '$username'";
        $result = query($sql);
        $row = fetch_array($result);
        $db_password = $row['password'];
            
        if(password_verify($old_password, $db_password)){
            
            $new_password = password_hash($new_password, PASSWORD_DEFAULT);
            
            $sql = "UPDATE users SET password = '".escape($new_password)."' WHERE username = '$username'";
            query($sql);
            
            echo "Password Updated. <br><br>";    
        } else { validation_errors("Incorrect Password. Please try current password again.");}
        
        } else {validation_errors("New passwords do not match.");}
    } 
}

/** Delete User From Database **/
function delete_user($id){
    $sql = "SELECT * FROM users WHERE id = '$id'";
    $result = query($sql);
    $row = fetch_array($result);
    if($row['access'] != '2'){
        $sql = "DELETE FROM users WHERE id='$id'";
        query($sql);
        $msg = "Deleted the user ";
        $msg .= $row['first_name'];
        $msg .= " ";
        $msg .= $row['last_name'];
        echo $msg;
    } else {
        echo "Cannot Delete Super User.";
    }
}

/** Make User An Admin **/
function make_admin($id){
     $sql = "SELECT * FROM users WHERE id = '$id'";
    $result = query($sql);
    $row = fetch_array($result);
    if($row['access'] != '2'){
        $sql = "UPDATE users SET access = '1' WHERE id = $id";
        query($sql);
        $msg = "Made the user ";
        $msg .= $row['first_name'];
        $msg .= " ";
        $msg .= $row['last_name'];
        $msg .= " an admin";
        echo $msg;
} else {
        echo "Cannot Change Super User Role.";
    }
}

/** Remove Admin Rights **/
function remove_admin($id){
     $sql = "SELECT * FROM users WHERE id = '$id'";
    $result = query($sql);
    $row = fetch_array($result);
    if($row['access'] != '2'){
        $sql = "UPDATE users SET access = '0' WHERE id = $id";
        query($sql);
        $msg = "Made the user ";
        $msg .= $row['first_name'];
        $msg .= " ";
        $msg .= $row['last_name'];
        $msg .= " a Client";
        echo $msg;
} else {
        echo "Cannot Change Super User Role.";
    }
}


/** Create Event Function **/
function create_event($event_name, $event_start, $event_stop, $event_description, $max_attendees, $creator_id, $event_type, $event_array){
        
        $sql = "INSERT INTO events(event_name, event_start, event_stop, event_description, max_attendees, creator_id, event_type, event_array) VALUES ('".escape($event_name)."', '".escape($event_start)."', '".escape($event_stop)."', '".escape($event_description)."', '".escape($max_attendees)."', $creator_id, '".escape($event_type)."', '$event_array')";
        $result = query($sql);
        return true;
    }

/** Validate Create Function **/
function validate_create_event(){
    if(isset($_POST['create_event'])){
        
        $errors = [];
        $min = 3;
        $max = 255;
        
        $event_name = clean($_POST['event_name']);
        $event_start = clean($_POST['event_start']);
        $event_stop = clean($_POST['event_stop']);
        $event_description = clean($_POST['event_description']);
        $max_attendees = clean($_POST['max_attendees']);
        $creator_id = call_users('id');
        $event_type = clean($_POST['option']);
        $event_array = array();
        
        $event_array = serialize($event_array); 
        
        if($event_type == 'attendees'){
            $event_type = '0';
        }
        if($event_type == 'rooms'){
            $event_type = '1';
        }
        if($event_type == 'seats'){
            $event_type = '2';
        }
        
        $sql = get_time();
        $current_time = query($sql);
        $current_time = fetch_array($current_time);
        $current_time = $current_time[0];
        
        
        
        if(strlen($event_name) < $min){
            $errors[] = "Event name must be more than {$min} characters.";
        }
        
        if(strlen($event_description) < $min){
            $errors[] = "Event description must be more than {$min} characters.";
        }
        if(strlen($event_description) > $max){
            $errors[] = "Event description cannot be more than {$max} characters.";
        }
        
        if(strtotime($event_start) > strtotime($event_stop)){
            $errors[] = "Start time cannot be after end time.";
        }
        if(strtotime($event_start) < strtotime($current_time)){
            $errors[] = "Start time cannot be in the past.";
        }
        if($max_attendees <= '0'){
            $errors[] = "Attendees must be more than 0.";
        }
        
        if(!empty($errors)){
            foreach($errors as $error){
                validation_errors($error);
            }
        } else {
            if(create_event($event_name, $event_start, $event_stop, $event_description, $max_attendees, $creator_id, $event_type, $event_array)){
                echo "Event created.";
            } else {
                echo "Event could not be created.";
            }
        }   
    }   
}

/** Book Event Function **/
function book_event($event_id){
    $user_id = call_users('id');
    $sql = "SELECT * FROM bookings WHERE event_id='$event_id' AND user_id='$user_id'";
    $result = query($sql);
    if(row_count($result) == '0'){
    $sql = "INSERT INTO bookings(event_id, user_id) VALUES ('$event_id', '$user_id')";
    $result = query($sql);
    $sql = "UPDATE events SET people_booked=people_booked + 1 WHERE id='$event_id'";
    $result = query($sql);
    redirect("mybookings.php");
    } else {
        echo "You are already booked on this event.";
    }
}

function book_event_number($event_id){
    if(isset($_POST['book_in'])){
        $requested = $_POST['selected_number'];
        $user_id = call_users('id');
        $sql = "SELECT * FROM bookings WHERE event_id='$event_id' AND user_id='$user_id'";
        $result = query($sql);
        if(row_count($result) == '0'){
         
        $maxbookable = event_details($event_id, 'max_attendees');
        
        //Max bookable
        $maxbookable = ($maxbookable + 1);
            
        //Array of booked seats
        $booked = event_details($event_id, 'event_array');
        $booked = unserialize($booked);
            
        //User Array
        $store = array();
            
        //requested plus one
        $booking = ($requested+1);
            
        //Stop Value;
        $stop = 0;

        //Initial check value
        $check = $booking;
            
        //Make sure booking seats are avilable
        if($booking > ($maxbookable - count($booked)) || $booking > $maxbookable){
            $errors[] = "Sorry, that many reservations are not available.";
        } else {
        
            //If array empty, give first positions
            if(count($booked) == 0){
                for($c = 1; $c < ($booking); ++$c){
                array_push($booked, $c);
                array_push($store, $c);
                $stop = 1;
            }
                
            } else {
                
                //Increment check value if not found
                for ($x = $check; $x <= $maxbookable; ++$x){

                    $check = $x;    
                
                    //If first number isn't 1 it doesnt have anything to compare against, this function checks if best fit is before first number
                    if($booked[0] > 1){
                        if(($booked[0] - 1) == ($check - 1)){
                            for($c = 1; $c < ($booking); ++$c){
                                array_push($booked, $c);
                                array_push($store, $c);
                                $stop = 1;
                            }
                        break;
                        }
                    }
                    
                    //Cycle through bookings
                    for ($i = 0; $i < count($booked); ++$i) {

                        //Ensure not out of bounds
                        if(($i+1) < count($booked)){
                            //If checked matches
                            if (($booked[$i+1] - $booked[$i]) == $check){
                                if(($booked[$i] + $booking) > $maxbookable){
                                    $errors[] = "Cannot book that many reservations together.";
                                } else {
                                    for($c = 1; $c < ($booking); ++$c){
                                        array_push($booked, ($booked[$i] + $c));
                                        array_push($store, ($booked[$i] + $c));
                                        $stop = 1;
                                    }
                                    break;
                                }
                            }
                        }
                    }
                    if ($stop == 1){
                        break;
                    }
                }
                //If no value found, add on to last bookings
                if($stop == 0){
                    if((max($booked) + $booking) > $maxbookable){
                        $errors[] = "Cannot book that many reservations together.";
                    } else {
                        $max = max($booked);
                        for($c = 1; $c < ($booking); ++$c){
                            array_push($booked, ($max + $c));
                            array_push($store, ($max + $c));
                            $stop = 1;
                        }
                    }   
                }
            }
        }
            
        if(!empty($errors)){
            foreach($errors as $error){
                validation_errors($error);
            }
        } else { 
        
        sort($store);
        sort($booked);
        $store = serialize($store);
        $booked = serialize($booked);    
        $sql = "UPDATE events SET event_array='$booked' WHERE id='$event_id'";
        $result = query($sql);
        $sql = "INSERT INTO bookings(event_id, user_id, given_number) VALUES ('$event_id', '$user_id', '$store')";
        $result = query($sql);
        
        
        $sql = "UPDATE events SET people_booked=people_booked + $requested WHERE id='$event_id'";
        $result = query($sql);
        redirect("mybookings.php"); 
        }
        //Next array
        } else {
            
        $maxbookable = event_details($event_id, 'max_attendees');
        
        //Max bookable
        $maxbookable = ($maxbookable + 1);
            
        //Array of booked seats
        $booked = event_details($event_id, 'event_array');
        $booked = unserialize($booked);
  
        //User Array
        $user_id = call_users('id');   
        $sql = "SELECT * FROM bookings WHERE event_id='$event_id' AND user_id='$user_id'";
        $result = query($sql);
        $row = fetch_array($result);
        $store = $row['given_number'];
        $store = unserialize($store);
            
         //requested plus one
        $booking = ($requested+1);
            
        //Stop Value;
        $stop = 0;

        //Initial check value
        $check = $booking;
            
        //Make sure booking seats are avilable
        if($booking > ($maxbookable - count($booked)) || $booking > $maxbookable){
            $errors[] = "Sorry, that many reservations are not available.";
        } else {
        
            //If array empty, give first positions
            if(count($booked) == 0){
                for($c = 1; $c < ($booking); ++$c){
                array_push($booked, $c);
                array_push($store, $c);
                $stop = 1;
            }
                
            } else {
                
                //Increment check value if not found
                for ($x = $check; $x <= $maxbookable; ++$x){

                    $check = $x;    
                
                    //If first number isn't 1 it doesnt have anything to compare against, this function checks if best fit is before first number
                    if($booked[0] > 1){
                        if(($booked[0] - 1) == ($check - 1)){
                            for($c = 1; $c < ($booking); ++$c){
                                array_push($booked, $c);
                                array_push($store, $c);
                                $stop = 1;
                            }
                        break;
                        }
                    }
                    
                    //Cycle through bookings
                    for ($i = 0; $i < count($booked); ++$i) {

                        //Ensure not out of bounds
                        if(($i+1) < count($booked)){
                            //If checked matches
                            if (($booked[$i+1] - $booked[$i]) == $check){
                                if(($booked[$i] + $booking) > $maxbookable){
                                    $errors[] = "Cannot book that many reservations together.";
                                } else {
                                    for($c = 1; $c < ($booking); ++$c){
                                        array_push($booked, ($booked[$i] + $c));
                                        array_push($store, ($booked[$i] + $c));
                                        $stop = 1;
                                    }
                                    break;
                                }
                            }
                        }
                    }
                    if ($stop == 1){
                        break;
                    }
                }
                //If no value found, add on to last bookings
                if($stop == 0){
                    if((max($booked) + $booking) > $maxbookable){
                        $errors[] = "Cannot book that many reservations together.";
                    } else {
                        $max = max($booked);
                        for($c = 1; $c < ($booking); ++$c){
                            array_push($booked, ($max + $c));
                            array_push($store, ($max + $c));
                            $stop = 1;
                        }
                    }   
                }
            }
        }
            
        if(!empty($errors)){
            foreach($errors as $error){
                validation_errors($error);
            }
        } else { 
        
        

                    
        sort($store);
        sort($booked);
        $store = serialize($store);
        $booked = serialize($booked);    
        $sql = "UPDATE events SET event_array='$booked' WHERE id='$event_id'";
        $result = query($sql);
        $sql = "UPDATE bookings SET given_number='$store' WHERE event_id='$event_id' AND user_id='$user_id'";
        $result = query($sql);
        
        
        $sql = "UPDATE events SET people_booked=people_booked + $requested WHERE id='$event_id'";
        $result = query($sql);
        redirect("mybookings.php");   
        }
        }
        
    }
}

function grab_given_numbers($event_id, $user_id){
    $sql = "SELECT * FROM bookings WHERE event_id='$event_id' AND user_id='$user_id'";
    $result = query($sql);
    $row = fetch_array($result);
    $store = $row['given_number'];
    $store = unserialize($store);
    $withComma = implode(", ", $store);
    return $withComma;
}

/** Cancel User's Booking **/
function cancel_booking($event_id){
    $user_id = call_users('id');
    $sql = "DELETE FROM bookings WHERE event_id='$event_id' AND user_id='$user_id'";
    $result = query($sql);
    $sql = "UPDATE events SET people_booked=people_booked - 1 WHERE id='$event_id'";
    $result = query($sql);
    echo "Booking Cancelled.";   
}

function cancel_booking_number($event_id){
    $user_id = call_users('id');
    
    
    
    
    $sql = "SELECT * FROM bookings WHERE event_id='$event_id' AND user_id='$user_id'";
    $result = query($sql);
    $row = fetch_array($result);
    $store = $row['given_number'];
    $store = unserialize($store);
    $number = count($store);
    
    $booked = event_details($event_id, 'event_array');
    $booked = unserialize($booked);
    $booked = array_diff($booked, $store);
    sort($booked);
    $booked = serialize($booked);
    $sql = "UPDATE events SET event_array='$booked' WHERE id='$event_id'";
    $result = query($sql);
    
    $sql = "DELETE FROM bookings WHERE event_id='$event_id' AND user_id='$user_id'";
    $result = query($sql);
    $sql = "UPDATE events SET people_booked=people_booked - $number WHERE id='$event_id'";
    $result = query($sql);
    redirect("mybookings.php");  
}

function cancel_event_reservations($event_id, $user_id){
    
    $sql = "SELECT * FROM bookings WHERE event_id='$event_id' AND user_id='$user_id'";
    $result = query($sql);
    $row = fetch_array($result);
    $store = $row['given_number'];
    $store = unserialize($store);
    $number = count($store);
    
    $booked = event_details($event_id, 'event_array');
    $booked = unserialize($booked);
    $booked = array_diff($booked, $store);
    sort($booked);
    $booked = serialize($booked);
    $sql = "UPDATE events SET event_array='$booked' WHERE id='$event_id'";
    $result = query($sql);
    
    $sql = "DELETE FROM bookings WHERE event_id='$event_id' AND user_id='$user_id'";
    $result = query($sql);
    $sql = "UPDATE events SET people_booked=people_booked - $number WHERE id='$event_id'";
    $result = query($sql);
    redirect("myevents.php");  
}

/** Cancel Event **/
function cancel_event($event_id){
    $select_users_query = "SELECT user_id FROM bookings WHERE event_id='$event_id'";
    $select_query = 
    $sql = "SELECT * FROM events WHERE id='$event_id'";
    $result = query($sql);
    $row = fetch_array($result);
    $creator_id = $row['creator_id'];
    $user_id = call_users('id');
    if($creator_id == $user_id){
        $sql = "DELETE FROM events where id='$event_id'";
        $sql2 = "DELETE FROM bookings where event_id='$event_id'";
        
        
        $select_users_query = "SELECT * FROM bookings WHERE event_id='$event_id'";
        $select_users = query($select_users_query);
        while($row = mysqli_fetch_assoc($select_users)){
            $user_id = $row['user_id'];
        /** Email Parameters **/
        $email_address = user_details($user_id, 'email');
        $subject = "An Event Has Been Cancelled! ";
        $subject .= call_settings('title');
        $msg = "Unfortunately the event ";
        $msg .= event_details($event_id, 'event_name');
        $msg .= " that was scheduled for ";
        $msg .= event_details($event_id, 'event_start');
        $msg .= " has been cancelled. Please login for your updated schedule of events. ";
        $msg .= call_settings('url');
        $headers = "From: ";
        $headers .= call_settings('admin_email');
        send_email($email_address, $subject, $msg, $headers);
        }
        
        $result = query($sql);
        $result2 = query($sql2);
        echo "Event Cancelled. All attendees will be notified. ";
        
    } else {
        echo "You did not create this event, so cannot delete it.";
    }
}

/** Remove Attendee **/
function remove_attendee($event_id, $user_id){
    /** Check If User Created Event **/
    $sql = "SELECT * FROM events WHERE id='$event_id'";
    $result = query($sql);
    $row = fetch_array($result);
    $my_id = call_users('id');
    $creator_id = $row['creator_id'];
    if($my_id == $row['creator_id']){
        $sql2 = "DELETE FROM bookings WHERE event_id='$event_id' AND user_id='$user_id'";
        $sql3 = "UPDATE events SET people_booked=people_booked - 1 WHERE id='$event_id'";
        $result2 = query($sql2);
        $result3 = query($sql3);
        
        /** Email Parameters **/
    $email_address = user_details($user_id, 'email');
    $subject = "You have been removed from an event! ";
    $subject .= call_settings('title');
    $msg = "You have been removed from the event: ";
    $msg .= event_details($event_id, 'event_name');
    $msg .= ", that was scheduled for ";
    $msg .= event_details($event_id, 'event_start');
    $msg .= ". Please login to message the host ";
    $msg .= user_details($creator_id, 'first_name');
    $msg .= " ";
    $msg .= user_details($creator_id, 'last_name');
    $msg .= " if you have any queries: ";
    $msg .= call_settings('url');
    $headers = "From: ";
    $headers .= call_settings('admin_email');
    send_email($email_address, $subject, $msg, $headers);
        echo "Attendee Removed.";
    } else {
        echo "You did not create this event, so cannot remove this attendee.";
    }   
}
/** Send Message Function **/
function send_message($id){
    if(isset($_POST['send_message'])){
    $my_id = call_users('id');
        
    /** Validation **/
    $message = clean($_POST['message']);
    $min = 3;
    $max = 255;
        
    if(strlen($message) < $min){
            $errors[] = "Message must be more than $min characters";
        }
    if(strlen($message) > $max){
            $errors[] = "Message cannot be more than $max characters";
        }
        
        if(!empty($errors)){
            foreach($errors as $error){
                validation_errors($error);
            }
        } else {
    
    $timequery = get_time();
    $current_time = query($timequery);
    $current_time = fetch_array($current_time);
    $current_time = $current_time[0];
    
    $sql = "INSERT INTO messages(to_user, from_user, date, message) VALUES ('$id', '$my_id', '$current_time', '".escape($message)."')";
    $result = query($sql);
    
    $update_messages = "UPDATE users SET messages=messages + 1 WHERE id='$id'";
    $result2 = query($update_messages);
        
    /** Email Parameters **/
    $email_address = user_details($id, 'email');
    $subject = "You Received a Private Message! ";
    $subject .= call_settings('title');
    $msg = "You received a private message from ";
    $msg .= call_users('first_name');
    $msg .= " ";
    $msg .= call_users('last_name');
    $msg .= ", please login to check it: ";
    $msg .= call_settings('url');
    $headers = "From: ";
    $headers .= call_settings('admin_email');
    send_email($email_address, $subject, $msg, $headers);
    
    echo "Message sent";
        }
    }
}

/** Delete Message Function **/
function delete_message($message_id){
    $check_ownership_query = "SELECT * FROM messages WHERE message_id='$message_id'";
    $check_ownership = query($check_ownership_query);
    $row = fetch_array($check_ownership);
    $my_id = call_users('id');
    if($my_id == $row['to_user']){
        $delete_message_query = "DELETE FROM messages WHERE message_id='$message_id' AND to_user='$my_id'";
        $delete_message = query($delete_message_query);
        echo "Message deleted.";
    } else {
        echo "Cannot delete messaged. Message was not addressed to you.";
    }   
}

?>