<?php
/** Helper Functions **/

/** Clean HTML **/
function clean($string){
    return htmlentities($string);
}

/** Redirect **/
function redirect($location){
    return header("Location: {$location}");
}

/** Set Session Message **/
function set_message($message){
    if(!empty($message)){
        $_SESSION['message'] = $message;
    } else {
        $message = "";
    }
}

/** Display Session Message **/
function display_message(){
    if(isset($_SESSION['message'])){
        echo $_SESSION['message'];
        unset($_SESSION['message']);
    }
}

/** Generate Random Security Token **/
function token_generator(){
    $token = $_SESSION['token'] = md5(uniqid(mt_rand(), true));
    return $token;
}


/** Error Message Printer **/
function validation_errors($error_message){
    $message = <<<DELIMITER
    <div class="alert-box warning"><span>warning: </span>$error_message</div>
DELIMITER;
    echo $message;
}

/** Check If Email Exists In DB **/
function email_exists($email_address) {
    $sql = "SELECT id FROM users WHERE email = '$email_address'";
    $result = query($sql);
    if(row_count($result) == 1){
        return true;
    } else {
        return false;
    }
}

/** Check If Username Exists In DB **/
function username_exists($username) {
    $sql = "SELECT id FROM users WHERE username = '$username'";
    $result = query($sql);
    if(row_count($result) == 1){
        return true;
    } else {
        return false;
    }
}

/** Send Email **/
function send_email($email, $subject, $msg, $headers){
    return mail($email, $subject, $msg, $headers);
}


/** Grab Details **/
function call_users($request){
    if(isset($_SESSION['username'])){
    $username = $_SESSION['username'];    
    } else if(isset($_COOKIE['username'])){   
    $username = $_COOKIE['username'];    
    }
    $sql = "SELECT * FROM users WHERE username = '$username'";
    $result = query($sql);
    $row = fetch_array($result);
    return $row[$request];
}

/** Grab Settings **/
function call_settings($request){
    $sql = "SELECT * FROM settings WHERE id = '1'";
    $result = query($sql);
    $row = fetch_array($result);
    return $row[$request];
}

/** Grab Other User's Details **/
function user_details($id, $request){
    $sql = "SELECT * FROM users WHERE id = $id";
    $result = query($sql);
    $row = fetch_array($result);
    return $row[$request];
}

/** Grab Event Details **/
function event_details($id, $request){
    $sql = "SELECT * FROM events WHERE id = $id";
    $result = query($sql);
    $row = fetch_array($result);
    return $row[$request];
}

function get_time(){
    $timezone = call_settings('timezone');
    return "SELECT CONVERT_TZ(NOW(), @@session.time_zone, '$timezone')";
}
?>
