<?php

/** Registration Validaiton **/
function validate_user_registration(){
    $errors = [];
    $usermin = 3;
    $usermax = 12;
    $phonelen = 11;
    if(isset($_POST['register_submit'])){
        
        $first_name = clean($_POST['first_name']);
        $last_name = clean($_POST['last_name']);
        $phone_number = clean($_POST['phone_number']);
        $username = clean($_POST['username']);
        $email_address = clean($_POST['email_address']);
        $password = clean($_POST['password']);
        $confirm_password = clean($_POST['confirm_password']); 
    
/** Username Validation **/    
    if(strlen($username) < $usermin){
        $errors[] = "Your username must be more than {$usermin} characters.";
    }
    if(strlen($username) > $usermax){
        $errors[] = "Your username must be less than {$usermax} chatacters.";
    }   
    if(username_exists($username)){
        $errors[] = "Username is already registered. Pick another.";
    }
        
/** Phone Number Validation **/
    if(strlen($phone_number) != $phonelen){
        $errors[] = "Your contact number must be {$phonelen} digits.";
    }
        
/** Email Validation **/
    if(email_exists($email_address)){
        $errors[] = "Email is already registered.";
    }
     
/** Passwords validation **/        
    if($password !== $confirm_password){
        $errors[] = "Your passwords do not match.";
    }
    
/** Print Errors **/    
    if(!empty($errors)){
        foreach($errors as $error){
            validation_errors($error);
            }
        } else {
        if(register_user($first_name, $last_name, $phone_number, $username, $email_address, $password)){
            
            set_message("<p>Thank you for joining us!<br>Check your inbox or spam folder to activate your account.</p>");
            
            redirect("confirmation.php");
        } else {
            
            set_message("<p>Sorry we could not register the user.</p>");
            
            redirect("confirmation.php");
        }
        }
    }
}

/** Registration function, after validation **/
function register_user($first_name, $last_name, $phone_number, $username, $email_address, $password){
    $first_name = escape($first_name);
    $last_name = escape($last_name);
    $phone_number = escape($phone_number);
    $username = escape($username);
    $email_address = escape($email_address);
    $password = escape($password);
    if(email_exists($email_address)) {
        return false;
    } else if(username_exists($username)){
        return false;
    } else {
        
        /** Hash Password **/
        $password = password_hash($password, PASSWORD_DEFAULT);
        $validation = md5($username + microtime());
        
        /** Insert Query **/
        $sql = "INSERT INTO users(first_name, last_name, phone_number, username, email, password, validation_code, active, access) VALUES('$first_name','$last_name','$phone_number','$username','$email_address','$password','$validation', 0, '')";
        $result = query($sql);
        confirm($result);
        
        /** Email Parameters **/
        $subject = "Activate Account";
        $msg = "Please click the link below to activate your account: ";
        $msg .= call_settings('url');
        $msg .= "activate.php?email=$email_address&code=$validation";
        $headers = "From: ";
        $headers .= call_settings('admin_email');
        send_email($email_address, $subject, $msg, $headers);
        
        return true;
    }  
}

/** Activate User **/

function activate_user(){
    if($_SERVER['REQUEST_METHOD'] == "GET"){
        if(isset($_GET['email'])) {
            $email = clean($_GET['email']);
            $validation = clean($_GET['code']);
            
            /** Compare validatio code and email **/
            $sql = "SELECT id FROM users WHERE email = '".escape($_GET['email'])."' AND validation_code = '".escape($_GET['code'])."'";
            $result = query($sql);
            confirm($result);
            
            /** Activate Account Query **/
            if(row_count($result) == 1){
            $sql2 = "UPDATE users SET active = 1, validation_code = 0 WHERE email = '".escape($email)."' AND validation_code = '".escape($validation)."'";
            $result2 = query($sql2);
            confirm($result2);
            set_message("<p>Your account has been activated. You may now Login.</p>");
            redirect("confirmation.php");
            } else {
                set_message("<p>Incorrect activation code.</p>"); 
                redirect("confirmation.php");
            }
        }  
    }
}
?>
